// Euler (IC[) ̊֐
unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    LabeledEdit1: TLabeledEdit;
    CheckBox1: TCheckBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// Euler̊֐ɉ{IȃvO
// ő񐔂1łlJEg܂B
function phi_gcd(n : cardinal): cardinal;
var
  i, res : cardinal;

  // ő
  function gcd(a, b : cardinal): cardinal;
  var
    tmp : cardinal;
  begin
    while b > 0 do begin
      tmp := a mod b;
      a := b;
      b := tmp;
    end;
    result := a;
  end;

begin
  res := 1;                           // q1̕
  for i := 2 to n - 1 do
    if gcd(i, n) = 1 then inc(res);   // ő񐔂1CNg
  result := res;
end;

//---------------------------------------
// ό  fɂ
// (n)nE(1-1/p)
// p  n ̑fqŜɂ킽
function phi(n : cardinal): cardinal;
var
 p, t : cardinal;
begin
  t := n;
  if n mod 2 = 0 then begin       // 2
    t := t div 2;                 // t = t(1-1/p)  = t/2
    repeat
      n := n div 2;
    until n mod 2 <> 0;
  end;
  p := 3;                         // 3ȏ
  while n div p >= p do begin
    if n mod p = 0 then begin
      t := (t div p) * (p - 1);   // t = t(1-1/p)
      repeat
        n := n div p;
      until n mod p <> 0;
    end;
    inc(p, 2);
  end;
  if n > 1 then t := (t div n) * (n - 1);   // Ō̒l
  result := t;
end;

//-------------------------------------------
procedure TForm1.BitBtn1Click(Sender: TObject);
const
  sp = ' ';
var
  i, j, k, h : cardinal;
  LL, s : string;
begin
  memo1.Clear;
  memo1.Font.Name := 'lr SVbN';
  LL := '     ';
  for i := 1 to 10 do begin
    s := '+' + inttostr(i);
    h := 4 - length(s);
    for k := 0 to h do s := sp + s;
    LL := LL + s;
  end;
  memo1.Lines.Append(LL);
  LL := '     ';
  for i := 1 to 50 do LL := LL + '-';
  memo1.Lines.Append(LL);
  for i := 0 to 24 do begin
    s := intTostr(i * 10);
    h := 3 - length(s);
    for k := 0 to h do s := sp + s;
    s := s + '|';
    LL := s;
    for j := 1 to 10 do begin
      if checkbox1.Checked then
        s := intTostr(phi_gcd(10 * i + j))
      else
        s := intTostr(phi(10 * i + j));
      h := 4 - length(s);
      for k := 0 to h do s := sp + s;
      LL := LL + s;
    end;
    memo1.Lines.Append(LL);
  end;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
var
  x, y: cardinal;
  ch : integer;
begin
  val(labelededit1.Text, x, ch);
  if ch <> 0 then begin
    application.MessageBox('͒lɊԈႢ܂','',0);
    exit;
  end;
  memo1.Clear;
  memo1.Font.Name := 'Tahoma';
  memo1.Lines.Append('IC[̃ӊ֐ig[VFg֐j');
  if checkbox1.Checked = true then
    y := phi_gcd(x)
  else
    y := phi(x);
  memo1.Lines.Append('(' + inttostr(x) + ')= ' + inttostr(y));
end;

end.
